Attribute VB_Name = "Module1"
Option Explicit

'View MR logo
Public Sub DrawMR(sFile As String, Src As enm_Source)
    
On Error GoTo ErrorHandler

    Dim btCompMR()      As Byte
    Dim btUncompMR()    As Byte
    Dim strIPData       As String
    Dim strMRData       As String
    Dim strMRpallete    As String
    Dim lngMRfs         As Long
    Dim lngMRoffset     As Long
    Dim lngMRwidth      As Long
    Dim lngMRheight     As Long
    Dim lngMRcolors     As Long
    Dim run             As String
    Dim i As Integer, j As Long, k As Integer
    Dim x As Integer, y As Integer
    Dim R As Byte, G As Byte, B As Byte

    Select Case Src
        '// IP.BIN
        Case SOURCE_IP
            Open sFile For Binary As #1
                ReDim btIP(LOF(1)) As Byte 'buffer for IP.BIN
                Get #1, , btIP() 'put IP.BIN in buffer
                strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
            Close #1
            
            If Mid$(strIPData, 14369, 2) <> "MR" Then
                MsgBox "There is no MR logo in this IP.BIN.", vbExclamation, "Error"
                Exit Sub
            End If
            
            'extract MR logo
            lngMRfs = CLng("&H" & Hex$(Asc(Mid$(strIPData, 14372, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strIPData, 14371, 1)))), "0") & Hex$(Asc(Mid$(strIPData, 14371, 1))))
            strMRData = Mid$(strIPData, 14369, lngMRfs)
    
        ''// MR
        Case SOURCE_MR
            Open sFile For Binary As #1
                ReDim btIP(LOF(1)) As Byte 'buffer
                Get #1, , btIP() 'put MR in buffer
                strMRData = StrConv(btIP(), vbUnicode) 'convert to a readable format
            Close #1
    End Select
    
    lngMRfs = CLng("&H" & Hex$(Asc(Mid$(strMRData, 4, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strMRData, 3, 1)))), "0") & Hex$(Asc(Mid$(strMRData, 3, 1))))
    lngMRoffset = CLng("&H" & Hex$(Asc(Mid$(strMRData, 12, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strMRData, 11, 1)))), "0") & Hex$(Asc(Mid$(strMRData, 11, 1))))
    lngMRwidth = CLng("&H" & Hex$(Asc(Mid$(strMRData, 16, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strMRData, 15, 1)))), "0") & Hex$(Asc(Mid$(strMRData, 15, 1))))
    lngMRheight = Asc(Mid$(strMRData, 19, 1))
    lngMRcolors = CLng("&H" & Hex$(Asc(Mid$(strMRData, 28, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strMRData, 27, 1)))), "0") & Hex$(Asc(Mid$(strMRData, 27, 1))))
    strMRpallete = Mid$(strMRData, 31, lngMRcolors * 4)
    
    'put each color (4 bytes) each in their own element
    For i = 0 To lngMRcolors - 1
        ReDim Preserve strPalette(i) 'redimension array, leaving previous elements
        strPalette(i) = Mid$(strMRpallete, i * 4 + 1, 4) 'put color i in element i
    Next
    
    'get compressed bitmap
    btCompMR = StrConv(Mid$(strMRData, lngMRoffset + 1), vbFromUnicode)

    'frmViewMR.Show
    
    'initialize variables
    i = 0
    j = 0
    
    ' **  Uncompress Compressed MR Bitmaps  **
    ' Ported From Delphi Code Written By kRYPT
    '    And Modified By [big_fury]SiZiOUS
    
    'uncompressed bitmap buffer
    ReDim btUncompMR(lngMRwidth * lngMRheight - 1)
    
    Do
        If btCompMR(i) < &H80 Then
            btUncompMR(j) = btCompMR(i) 'the bytes lower than 128 are recopied just as they are in the bitmap
            j = j + 1
            If j > UBound(btUncompMR) Then Exit Do
        Else
            If (btCompMR(i) = &H82) And (btCompMR(i + 1) >= &H80) Then
                'the tag &H82 is followed Nb of points decoded in Run
                run = btCompMR(i + 1) - &H80 + &H100
                
                For k = 1 To run
                    btUncompMR(j) = btCompMR(i + 2) 'by retaining only the 1 byte for each point
                    j = j + 1
                    If j > UBound(btUncompMR) Then Exit Do
                Next
                
                i = i + 2
            ElseIf btCompMR(i) = &H81 Then
                'the tag &H81 is followed by a byte giving Nb of points directly
                run = btCompMR(i + 1)
                
                For k = 1 To run
                    btUncompMR(j) = btCompMR(i + 2) 'idem: 1 byte on 2
                    j = j + 1
                    If j > UBound(btUncompMR) Then Exit Do
                Next
                
                i = i + 2
            Else
                'if > &H82 => code for Nb of points decoded in run
                run = btCompMR(i) - &H80
                
                For k = 1 To run
                    btUncompMR(j) = btCompMR(i + 1) 'coded on only one byte
                    j = j + 1
                    If j > UBound(btUncompMR) Then Exit Do
                Next
                
                i = i + 1
            End If
        End If
        i = i + 1
    Loop Until i >= (lngMRfs - lngMRoffset - 1)
    
    frmMain.Picture1.Width = (lngMRwidth * Screen.TwipsPerPixelX)
    frmMain.Picture1.Height = (lngMRheight * Screen.TwipsPerPixelY)
    frmMain.lblOffset.Caption = lngMRoffset
    frmMain.lblResolution.Caption = lngMRwidth & "x" & lngMRheight
    frmMain.lblColors.Caption = lngMRcolors
    frmMain.lblSize.Caption = (lngMRoffset + UBound(btCompMR) + 1) & " bytes (compressed) " & vbCrLf & _
                              (lngMRoffset + UBound(btUncompMR) + 1) & " bytes (uncompressed)"
    
    'reinitialize i
    i = 0
    
    For y = 0 To lngMRheight - 1 'loop the y coordinates
        For x = 0 To lngMRwidth - 1 'loop the x coordinates
            'get RGB values from palette for current pixel
            If btUncompMR(i) > UBound(strPalette) Then
                'fix for Windows CE
                R = Asc(Mid$(strPalette(0), 3, 1))
                G = Asc(Mid$(strPalette(0), 2, 1))
                B = Asc(Mid$(strPalette(0), 1, 1))
            Else
                R = Asc(Mid$(strPalette(btUncompMR(i)), 3, 1))
                G = Asc(Mid$(strPalette(btUncompMR(i)), 2, 1))
                B = Asc(Mid$(strPalette(btUncompMR(i)), 1, 1))
            End If
            
            'draw the pixel
            SetPixel frmMain.Picture1.hdc, x, y, RGB(R, G, B)
            
            'next pixel data
            i = i + 1
        Next
    Next
    
    'rest the drawn pixels
    frmMain.Picture1.Picture = frmMain.Picture1.image
    frmMain.Picture1.Refresh

    Exit Sub

ErrorHandler:
    Close
    MsgBox "DrawMR - modMR" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"
    
End Sub
